package com.paraview.parafacebaidu;

import android.content.Context;
import android.util.Log;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.Map;

public class APIServer {
    private static final String FACE_API_KEY = "Vkcx63kBlGrYpPjRPUVbnLMb";
    private static final String FACE_SECRET_KEY = "V0kQrauxu0N31UqYlSFC6yOB3NGvg6pa";
    private static final String BASE_URL = "https://aip.baidubce.com";
    private static final String ACCESS_TOEKN_URL = BASE_URL + "/oauth/2.0/token?";
    private static final String REG_URL = BASE_URL + "/rest/2.0/face/v3/faceset/user/add?";
    private static final String SEARCH_URL = BASE_URL + "/rest/2.0/face/v3/search?";
    private String accessToken;
    private String groupId;

    private  APIServer(){}
    private static volatile APIServer instance;

    public interface OnResultListener<T>{
        void onResult(T result) throws JSONException;
        void onError();
    }

//    public interface HttpResponseCallBack {
//
//        void onSuccess(JSONObject response);    //返回数据
//
//        void onFailure();   //网络连接错误 json解析错误
//    }

    public static APIServer getInstance() {
        if (instance == null){
            synchronized (APIServer.class){
                if (instance == null){
                    instance = new APIServer();
                }
            }
        }
        return instance;
    }

   public void init(Context context){
        //采用deviceId分组
//       NetworkUtils.doGet();
    }

    public void registerFaceWithImageBaseString(String imageStr, Object access_Token, Object userID, Object userName, Object groupID, final OnResultListener listener){
//        StringBuilder sd = new StringBuilder();
//        sd.append("user_id").append(userID);
//        sd.append("&user_info").append(userName);
//        sd.append("")
        JSONObject sd = new JSONObject();
        try {
//            sd.put("access_token", access_Token);
            sd.put("user_id", userID);
            sd.put("user_info", userName);
            sd.put("group_id", groupID);
            sd.put("image_type", "BASE64");
            sd.put("liveness_control", "NORMAL");
            sd.put("quality_control", "NORMAL");
            sd.put("image", imageStr);
        }catch (JSONException e) {
            e.printStackTrace();
        }
        Log.e("请求接口",REG_URL+sd.toString());
        NetworkUtils.doPost(REG_URL+"access_token=" + access_Token, sd.toString(), null, new NetworkUtils.HttpResponseCallBack() {
            @Override
            public void onSuccess(JSONObject response) throws JSONException {
                Log.e("返回结果",response.toString());
//                Map<String,Object>data = new HashMap<>();
//                Iterator it = response.keys();
//                while (it.hasNext()){
//                    Map.Entry<String, Object> entry = (Entry<String, Object>) it.next();
//                    data.put(entry.getKey(), entry.getValue());
//                }
                if (response.getString("error_msg").equals("SUCCESS")){//注册成功
                    JSONObject result = response.getJSONObject("result");
                    listener.onResult(result);
                }else {
                    listener.onError();
                }
            }

            @Override
            public void onFailure() {
listener.onError();
            }
        });
    }

    public void searchFaceWithImageBaseString(String imageStr, String access_Token,Object userID,Object groupID,final OnResultListener listener){
//        StringBuilder sd = new StringBuilder();
//        sd.append("user_id").append(userID);
//        sd.append("&user_info").append(userName);
//        sd.append("")
        JSONObject sd = new JSONObject();
        try {
//        Log.e("请求的access_Token",access_Token);
//        sd.put("access_token",access_Token);
        sd.put("user_id",userID);
        sd.put("group_id_list",groupID);
        sd.put("image_type","BASE64");
        sd.put("liveness_control","NORMAL");
        sd.put("quality_control","NORMAL");
        sd.put("image",imageStr);
        }catch (JSONException e) {
            e.printStackTrace();
        }
        Log.e("请求接口",SEARCH_URL +"access_token=");
        NetworkUtils.doPost(SEARCH_URL +"access_token=" + access_Token, sd.toString(), null, new NetworkUtils.HttpResponseCallBack() {
            @Override
            public void onSuccess(JSONObject response) throws JSONException {
                Log.e("返回结果",response.toString());
                if (response.getString("error_msg").equals("SUCCESS")){//搜索成功
                    JSONObject result = response.getJSONObject("result");
                    JSONObject user_list = result.getJSONArray("user_list").optJSONObject(0);
                    Map<String,Object> dict = new HashMap<>();
                    dict.put("type",true);
                    dict.put("face_token",result.getString("face_token"));
                    dict.put("group_id",user_list.getString("group_id"));
                    dict.put("user_id",user_list.getString("user_id"));
                    //用户名
                    dict.put("user_info",user_list.getString("user_info"));
                    dict.put("score",user_list.getString("score"));

//                    Log.e("解析结果",dict.toString());
                    listener.onResult(dict);
                }else {//搜索失败
//                    Log.e("解析结果","ggggggggggg");
                    listener.onError();
                }
            }

            @Override
            public void onFailure() {
                listener.onError();
            }
        });
    }

    public void initAccessTokenWithAkSk(String ak,
                                        String sk,final OnResultListener listener) {
        StringBuilder sd = new StringBuilder();
        sd.append("client_id=").append(ak);
        sd.append("&client_secret=").append(sk);
        sd.append("&grant_type=client_credentials");
        Log.e("请求接口",ACCESS_TOEKN_URL+sd.toString());
        NetworkUtils.doGet(ACCESS_TOEKN_URL+sd.toString(), new NetworkUtils.HttpResponseCallBack() {
            @Override
            public void onSuccess(JSONObject response) throws JSONException {

                String accessToken = response.getString("access_token");
                if (accessToken != null) {
//                    https://aip.baidubce.com/oauth/2.0/token?grant_type=client_credentials&client_id=Vkcx63kBlGrYpPjRPUVbnLMb&client_secret=Vkcx63kBlGrYpPjRPUVbnLMb
                    //创建一个SharedPreferences对象
//                    SharedPreferences settings = getSharedPreferences("data",Context.MODE_PRIVATE);
//                    SharedPreferences settings = SharedPreferences.OnSharedPreferenceChangeListener("data",Context.MODE_PRIVATE);
                    //实例化SharedPreferences.Editor对象
//                    SharedPreferences.Editor editor = SharedPreferences edit();
//                    //将获取过来的值放入文件
//                    editor.putString("access_token",accessToken);
//                    //提交
//                    editor.commit();
                    //读取数据：
//                    SharedPreferences sharedPreferences= this.getSharedPreferences("data", Context .MODE_PRIVATE);
//                    String userId=sharedPreferences.getString("access_token","");

//                    Log.e("token的值",userId);

                    listener.onResult(accessToken);
                }else {
                    listener.onError();
                }
            }
            @Override
            public void onFailure() {
                Log.e("失败返回","失败返回");
                listener.onError();
            }
        });
    }
}
