package com.paraview.parafacebaidu;

import android.app.Activity;
import android.app.Application;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.util.Log;
import org.json.JSONException;
import org.json.JSONObject;

import androidx.annotation.NonNull;

import io.flutter.embedding.engine.plugins.FlutterPlugin;
import io.flutter.plugin.common.BinaryMessenger;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import io.flutter.embedding.engine.plugins.activity.ActivityAware;
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding;

import io.flutter.plugin.common.PluginRegistry;
import java.util.HashMap;
import java.util.Map;

import com.paraview.parafacebaidu.APIServer;

//import org.json.JSONObject;

/** ParafacebaiduPlugin */
public class ParafacebaiduPlugin implements FlutterPlugin, MethodCallHandler, ActivityAware {
  /// The MethodChannel that will the communication between Flutter and native Android
  ///
  /// This local reference serves to register the plugin with the Flutter Engine and unregister it
  /// when the Flutter Engine is detached from the Activity
  private MethodChannel channel;//parafacebaidu

  private static final String CHANNEL = "parafacebaidu";

  private static final int LIVENESS_REQUEST_CODE = 10110;

  private static final int DETECT_REQUEST_CODE = 10111;

  private FlutterPluginBinding pluginBinding;
  private ActivityPluginBinding activityBinding;
  private Application application;
  private Activity activity;

  private static LivenessCallback livenessCallback;
  private static DetectCallback detectCallback;
  private static MethodCall faceCall;
  private static Result faceResult;

  @Override
  public void onAttachedToEngine(@NonNull FlutterPluginBinding flutterPluginBinding) {
    pluginBinding = flutterPluginBinding;
    channel = new MethodChannel(flutterPluginBinding.getFlutterEngine().getDartExecutor(), "parafacebaidu");
    channel.setMethodCallHandler(this);

//    Log.e("token获取", "token获取");
  }

  @Override
  public void onAttachedToActivity(ActivityPluginBinding activityPluginBinding) {
    activityBinding = activityPluginBinding;
//    Log.e("token获取", "token获取");
    //通过该方法获取全局activity，application
    init(pluginBinding.getBinaryMessenger(),(Application) pluginBinding.getApplicationContext(),activityBinding.getActivity());

    activityPluginBinding.addActivityResultListener(new PluginRegistry.ActivityResultListener() {
      @Override
      public boolean onActivityResult(int requestCode, int resultCode, Intent data) {
        Log.e("BaiduFacePlugin",
                "onActivityResult: requestCode=" + requestCode + ", resultCode=" + resultCode + ", data=" + data);
        switch (requestCode) {
          case LIVENESS_REQUEST_CODE: {//活体检测
            if (livenessCallback != null && data != null) {
              if (data.getBooleanExtra("success", false)) {
//                resultMap.put("imageByte",Base64Utils.decode(base64Image,Base64Utils.NO_WRAP));
//String imageStr, Object access_Token, Object userID, Object userName, Object groupID, final OnResultListener listener


                livenessCallback.sucess(data.getStringExtra("image"));
              } else {
                livenessCallback.failed();
              }
            }
            break;
          }
          case DETECT_REQUEST_CODE: {//人脸采集
            if (data != null) {
              Log.e("人脸注册","走这里"+ faceCall.method);
              if (faceCall.method.equals("faceResgiter")) {
Log.e("人脸登陆","走这里" );
                //读取数据：
                SharedPreferences sharedPreferences= activity.getSharedPreferences("data", Context .MODE_PRIVATE);
                String access_Token =sharedPreferences.getString("access_token","");

                Map<String,Object> args = (Map<String, Object>)faceCall.arguments;

                APIServer.getInstance().registerFaceWithImageBaseString(data.getStringExtra("image"), access_Token, args.get("userID"), args.get("userName"), args.get("groupID"), new APIServer.OnResultListener() {
                  @Override
                  public void onResult(Object result) throws JSONException {
                    Log.e("结果出来啦","结果出来了");
                    JSONObject jsonObject = (JSONObject)result;
                    Map<String,Object>data = new HashMap<>();
                    data.put("face_token",jsonObject.getString("face_token"));
                    data.put("type",true);
                    faceResult.success(data);
//                    faceResult.success("测试");
                  }

                  @Override
                  public void onError() {
                    Map<String,Object>data = new HashMap<>();
                    faceResult.error("失败","失败","hh");
                  }
                });
              } else if (faceCall.method.equals("faceSearch")) {
                Log.e("人脸注册","走这里");
                //读取数据：
                SharedPreferences sharedPreferences= activity.getSharedPreferences("data", Context .MODE_PRIVATE);
                String access_Token =sharedPreferences.getString("access_token","");

                Map<String,Object> args = (Map<String, Object>)faceCall.arguments;

                APIServer.getInstance().searchFaceWithImageBaseString(data.getStringExtra("image"), access_Token, args.get("userID"), args.get("groupID"), new APIServer.OnResultListener() {
                  @Override
                  public void onResult(Object result) {
//                    faceResult.success(result);
                    faceResult.success((Map)result);
                  }

                  @Override
                  public void onError() {
//                    faceResult.success("测试");
                    faceResult.error("失败","失败","hh");
                  }
                });
              }
            }
//            if (detectCallback != null && data != null) {
//              if (data.getBooleanExtra("success", false)) {
//                detectCallback.sucess(data.getStringExtra("image"));
//              } else {
//                detectCallback.failed();
//              }
//            }
            break;
          }
          default:
        }
        return false;
      }
    });
  }

  @Override
  public void onDetachedFromActivity() {
    Log.e("结束","结束");
    activityBinding = null;
    channel.setMethodCallHandler(null);
    channel = null;
    application = null;
  }

  @Override
  public void onReattachedToActivityForConfigChanges(ActivityPluginBinding activityPluginBinding) {
    onAttachedToActivity(activityPluginBinding);
  }

  @Override
  public void onDetachedFromActivityForConfigChanges() {
    onDetachedFromActivity();
  }

  //新增代码
  private  void  init(final BinaryMessenger messenger,final Application application, final  Activity activity){
    this.activity = activity;
    this.application = application;

    channel = new MethodChannel(messenger,CHANNEL);
    channel.setMethodCallHandler(this);

  }

  @Override
  public void onMethodCall(@NonNull MethodCall call, @NonNull Result result) {
//    faceCall = call;
//    faceResult = result;
    APIServer.getInstance().initAccessTokenWithAkSk("Vkcx63kBlGrYpPjRPUVbnLMb", "V0kQrauxu0N31UqYlSFC6yOB3NGvg6pa", new APIServer.OnResultListener() {
      @Override
      public void onResult(Object result) {
        Log.e("token获取成功",(String) result);

                    //创建一个SharedPreferences对象
                    SharedPreferences settings = activity.getSharedPreferences("data",Context.MODE_PRIVATE);
                    //实例化SharedPreferences.Editor对象
                    SharedPreferences.Editor editor = settings.edit();
                    //将获取过来的值放入文件
                    editor.putString("access_token",(String) result);
                    //提交
                    editor.commit();
                    //读取数据：
                    SharedPreferences sharedPreferences= activity.getSharedPreferences("data", Context .MODE_PRIVATE);
                    String userId=sharedPreferences.getString("access_token","");

                    Log.e("token的值",userId);
      }

      @Override
      public void onError() {
        Log.e("token获取失败", "失败");
      }
    });
    if ("liveness".equals(call.method)) {
      livenessCallback = new LivenessCallback(result);
      liveness(call.hasArgument("language") ? call.<String>argument("language") : null);
    } else if ("detect".equals(call.method)||"faceResgiter".equals(call.method)||"faceSearch".equals(call.method)) {
      detectCallback = new DetectCallback(result);
      detect(call.hasArgument("language") ? call.<String>argument("language") : null,call,result);
    }else if (call.method.equals("getPlatformVersion")) {//系统示例方法，获取版本号
      result.success("Android " + android.os.Build.VERSION.RELEASE);
    } else {
      result.notImplemented();
    }
  }

  @Override
  public void onDetachedFromEngine(@NonNull FlutterPluginBinding binding) {
    channel.setMethodCallHandler(null);
  }

  private void detect(String language,MethodCall call,Result result) {
    faceCall = call;
    faceResult = result;
    if (activity != null){
      Intent intent = new Intent(activity, FaceDetectExpActivity.class);
      Bundle mBundle = new Bundle();
      mBundle.putString("language", (language == null || "".equals(language)) ? "zh" : language);
      intent.putExtras(mBundle);
      activity.startActivityForResult(intent, DETECT_REQUEST_CODE);
    }
  }

  private void liveness(String language) {
    Intent intent = new Intent(activity, FaceLivenessExpActivity.class);
    Bundle mBundle = new Bundle();
    mBundle.putString("language", (language == null || "".equals(language)) ? "zh" : language);
    intent.putExtras(mBundle);
    activity.startActivityForResult(intent, LIVENESS_REQUEST_CODE);
  }

  class LivenessCallback {

    private Result result;

    public LivenessCallback(Result result) {
      this.result = result;
    }

    public void sucess(String image) {
      Map<String, String> map = new HashMap<>();
      map.put("success", "true");
      map.put("image", image);
      result.success(map);
    }

    public void failed() {
      Map<String, String> map = new HashMap<>();
      map.put("success", "false");
      result.success(map);
    }

  }

  class DetectCallback {

    private Result result;

    public DetectCallback(Result result) {
      this.result = result;
    }

    public void sucess(String image) {
      Map<String, String> map = new HashMap<>();
      map.put("success", "true");
      map.put("image", image);
      result.success(map);
    }

    public void failed() {
      Map<String, String> map = new HashMap<>();
      map.put("success", "false");
      result.success(map);
    }

  }
}
