import 'package:flutter/material.dart';
import 'dart:async';

import 'package:flutter/services.dart';
import 'package:parafacebaidu/parafacebaidu.dart';
import 'package:parafacebaidu/faceuser.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatefulWidget {
  @override
  _MyAppState createState() => _MyAppState();
}

class _MyAppState extends State<MyApp> {
  String _platformVersion = 'Unknown';

  @override
  void initState() {
    super.initState();
    initPlatformState();
  }

  // Platform messages are asynchronous, so we initialize in an async method.
  Future<void> initPlatformState() async {
    String platformVersion;
    // Platform messages may fail, so we use a try/catch PlatformException.
    try {
      platformVersion = await Parafacebaidu.platformVersion;
    } on PlatformException {
      platformVersion = 'Failed to get platform version.';
    }

    // If the widget was removed from the tree while the asynchronous platform
    // message was in flight, we want to discard the reply rather than calling
    // setState to update our non-existent appearance.
    if (!mounted) return;

    setState(() {
      _platformVersion = platformVersion;
    });
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      home: Scaffold(
          appBar: AppBar(
            title: const Text('插件测试'),
          ),
          body: Column(
            mainAxisAlignment: MainAxisAlignment.center,
            crossAxisAlignment: CrossAxisAlignment.center,
            children: <Widget>[
              Text('Running on: $_platformVersion\n'),
              RaisedButton(
                  child: Text("打开liveness"),
                  onPressed: () {
                    _liveness();
                  }),
              RaisedButton(
                  child: Text("打开detect"),
                  onPressed: () {
                    _detect();
                  }),
              FloatingActionButton(
                onPressed: onNativeMethon,
              )
            ],
          )
          ),
    );
  }

  _liveness() async {
    LivenessResult result = await new Parafacebaidu().liveness();

    debugPrint('LivenessResult: $result');
    // Fluttertoast.showToast(msg: result.toString(), timeInSecForIosWeb: 4);

    // setState
  }

  _detect() async {
    DetectResult result = await new Parafacebaidu().detect();


    // debugPrint('DetectResult: $result');

    print('DetectResult: $result');
    // Fluttertoast.showToast(msg: result.toString(), timeInSecForIosWeb: 4);

    // setState
  }

  onNativeMethon() async {
    // try {
    //   var result = await Facebaidu.platformVersion;
    //   print('result == $result');
    // } catch (e) {}
    FaceUser user =
    FaceUser(userID: '123456', userName: '12345', groupID: '1234567');
    try {
      // var result = await Facebaidu.faceSearch(user);
      var result = await Parafacebaidu.faceSearch(user);
      print('result == $result');
    } catch (e) {}
  }
}
