

#import <UIKit/UIKit.h>
#import "ParaCircleView.h"
#import "ParaVideoCaptureDevice.h"

typedef enum : NSUInteger {
    CommonStatus,
    PoseStatus,
    occlusionStatus
} WarningStatus;

typedef void (^successCompletion)(NSDictionary* images, UIImage* originImage);
typedef void (^SigninSuccessCompletion)(NSDictionary* dict, NSString* message);

@interface ParaFaceBaseViewController : UIViewController

@property (nonatomic, readwrite, retain) ParaVideoCaptureDevice *videoCapture;
@property (nonatomic, readwrite, retain) UIImageView *displayImageView;
@property (nonatomic, readwrite, assign) BOOL hasFinished;
@property (nonatomic, readwrite, retain) UIImage* coverImage;
@property (nonatomic, readwrite, assign) CGRect previewRect;
@property (nonatomic, readwrite, assign) CGRect detectRect;
@property (nonatomic, readwrite, retain) ParaCircleView * circleView;
@property (nonatomic, readwrite, copy) successCompletion completion;
@property (nonatomic, readwrite, copy) SigninSuccessCompletion signinCompletion;

@property (nonatomic, strong) UIButton *closeButton;
@property (nonatomic, readwrite, retain) UILabel *remindLabel;

- (void)faceProcesss:(UIImage *)image;

- (void)startCapture;
- (void)stopCapture;

- (void)startAnimation;
- (void)stopAnimation;

- (void)closeAction;

- (void)onAppWillResignAction;
- (void)onAppBecomeActive;

- (void)warningStatus:(WarningStatus)status warning:(NSString *)warning;
- (void)singleActionSuccess:(BOOL)success;

@end
