//
//  ParaFaceManager.m
//  ParaFaceDemo
//
//  Created by ZhangSan on 2018/11/24.
//  Copyright © 2018年 PaiLa. All rights reserved.
//

#import "ParaFaceManager.h"
#import "ParaAFHTTPRequestSerializer.h"

//NSInteger const IntervalManager = 3;

@interface ParaFaceManager ()

@property(nonatomic) ParaAFHTTPRequestSerializer *requestSerializer;
@property(nonatomic) ParaAFJSONRequestSerializer *jsonRequestSerializer;

@end

@implementation ParaFaceManager

+ (instancetype)sharedInstance {
    static ParaFaceManager *instance = nil;
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        instance = [[ParaFaceManager alloc] init];
    });
    return instance;
}

- (instancetype)init {
    self = [super init];
    if (self) {
        
        
    }
    return self;
}

- (void)PostWithURL:(NSString *)url Params:(NSDictionary *)params completion:(FinishBlockWithObject)completionBlock
{
    NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:[NSURL URLWithString:url]];
    [request setHTTPMethod:@"POST"];

    NSData *data = [NSJSONSerialization dataWithJSONObject:params options:NSJSONWritingPrettyPrinted error:nil];
    NSString *jsonStr = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
    
    [request setValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
    [request setValue:@"application/json" forHTTPHeaderField:@"Accept"];
    [request setHTTPBody:[jsonStr dataUsingEncoding:NSUTF8StringEncoding]];
    //设置请求最长时间
    request.timeoutInterval = 3;
    NSError* error = nil;
    if ([url hasSuffix:@"oauth/2.0/token"]) {
        request = [[[ParaAFHTTPRequestSerializer serializer] requestBySerializingRequest:request withParameters:params error:&error] mutableCopy];
    } else {
        request = [[[ParaAFJSONRequestSerializer serializer] requestBySerializingRequest:request withParameters:params error:&error] mutableCopy];
    }
    
    NSURLSessionTask *task = [[NSURLSession sharedSession] dataTaskWithRequest:request completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        completionBlock(error,data);
        
    }];
    [task resume];
}

@end
