#import "ParafacebaiduPlugin.h"
//#import "Factory.h"
#import "FaceParameterConfig.h"
//#import <Face_SDK/Face_SDK.h>
#import "ParaVideoCaptureDevice.h"
#import "ParaCircleView.h"
#import "ParaDetectionViewController.h"
#import "ParaFaceBaseViewController.h"
#import "ParaFaceManager.h"
#import "ParaFaceNetAccessModel.h"
#import <IDLFaceSDK/IDLFaceSDK.h>

@implementation ParafacebaiduPlugin
+ (void)registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    
//    NSURL *url = [[NSBundle bundleForClass:[ParafacebaiduPlugin class]]URLForResource:@"FaceSDK" withExtension:@"bundle"];
//    NSBundle *bundle = [NSBundle bundleWithURL:url];
//
//    NSString * licensePAth = [bundle pathForResource:FACE_LICENSE_NAME ofType:FACE_LICENSE_SUFFIX];
    
    NSString * licensePAth = [[NSBundle mainBundle] pathForResource:FACE_LICENSE_NAME ofType:FACE_LICENSE_SUFFIX];
    
    NSAssert([[NSFileManager defaultManager] fileExistsAtPath:licensePAth], @"license文件路径不对，请仔细查看文档");
    [[FaceSDKManager sharedInstance]setLicenseID:FACE_LICENSE_ID andLocalLicenceFile:licensePAth];
    [[ParaFaceNetAccessModel sharedInstance]getAccessTokenWithAK:FACE_API_KEY SK:FACE_SECRET_KEY];
    
    NSLog(@"是否可以%@---%@", [[FaceSDKManager sharedInstance]canWork],licensePAth);
    
  FlutterMethodChannel* channel = [FlutterMethodChannel
      methodChannelWithName:@"parafacebaidu"
            binaryMessenger:[registrar messenger]];
  ParafacebaiduPlugin* instance = [[ParafacebaiduPlugin alloc] init];
 instance.hostViewController = [UIApplication sharedApplication].delegate.window.rootViewController;
  [registrar addMethodCallDelegate:instance channel:channel];
}

- (void)handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
  if ([@"getPlatformVersion" isEqualToString:call.method]) {
    result([@"iOS " stringByAppendingString:[[UIDevice currentDevice] systemVersion]]);
  }else if ([call.method isEqualToString:@"faceSearch"]) {//人脸搜索
          NSDictionary *dict = call.arguments;
          
          ParaDetectionViewController *vc = [[ParaDetectionViewController alloc]init];
          vc.completion = ^(NSDictionary *images, UIImage *originImage) {
              if (images[@"bestImage"] != nil && [images[@"bestImage"]count] != 0) {
                  NSData *data = [[NSData alloc]initWithBase64EncodedString:[images[@"bestImage"]lastObject] options:NSDataBase64DecodingIgnoreUnknownCharacters];
                  UIImage *bestImage = [UIImage imageWithData:data];
                  NSLog(@"bestImage == %@",bestImage);
                  NSString *bestImageStr = [[images[@"bestImage"]lastObject]copy];
                  [[ParaFaceNetAccessModel sharedInstance]searchFaceWithImageBaseString:bestImageStr userID:dict[@"userID"] groupID:dict[@"groupID"] completion:^(NSError * _Nonnull error, id  _Nonnull resultObject) {
                      NSDictionary* dict = [NSJSONSerialization JSONObjectWithData:resultObject options:NSJSONReadingAllowFragments error:nil];
                      NSLog(@"error=%@\n,result=%@",error,dict);
                      
                      NSMutableDictionary *resultDict = [NSMutableDictionary dictionary];
                      ////人脸搜索成功
                      if ([dict[@"error_msg"] isEqualToString:@"SUCCESS"]) {
                          [resultDict setValue:dict[@"result"][@"face_token"] forKey:@"face_token"];
                          [resultDict setValue:[NSNumber numberWithBool:true] forKey:@"type"];
                          NSArray *array = dict[@"result"][@"user_list"];
                          if (array.count>0) {
                              NSDictionary *userDict = array.firstObject;
                              //用户名
                              [resultDict setValue:userDict[@"user_info"] forKey:@"user_info"];
                              [resultDict setValue:userDict[@"score"] forKey:@"score"];
                              [resultDict setValue:userDict[@"user_id"] forKey:@"user_id"];
                              [resultDict setValue:userDict[@"group_id"] forKey:@"group_id"];
                          }
                      }else{
                          [resultDict setValue:[NSNumber numberWithBool:false] forKey:@"type"];
                      }
                      result(resultDict);
                  }];
              }
          };
          
  //        UIViewController *vc = [[UIViewController alloc]init];
          
//          UINavigationController *nav = [[UINavigationController alloc]initWithRootViewController:vc];
          vc.modalPresentationStyle = UIModalPresentationFullScreen;
          if (self.hostViewController != nil) {
              [self.hostViewController presentViewController:vc animated:YES completion:nil];
          }
      }else if ([call.method isEqualToString:@"faceResgiter"]){//人脸注册
          NSDictionary *dict = call.arguments;
          
          ParaDetectionViewController *vc = [[ParaDetectionViewController alloc]init];
          vc.completion = ^(NSDictionary *images, UIImage *originImage) {
              if (images[@"bestImage"] != nil && [images[@"bestImage"]count] != 0) {
                  NSData *data = [[NSData alloc]initWithBase64EncodedString:[images[@"bestImage"]lastObject] options:NSDataBase64DecodingIgnoreUnknownCharacters];
                  UIImage *bestImage = [UIImage imageWithData:data];
                  NSLog(@"bestImage == %@",bestImage);
                  NSString *bestImageStr = [[images[@"bestImage"]lastObject]copy];
                  [[ParaFaceNetAccessModel sharedInstance]registerFaceWithImageBaseString:bestImageStr userName:dict[@"userName"] userID:dict[@"userID"] groupID:dict[@"groupID"] completion:^(NSError * _Nonnull error, id  _Nonnull resultObject) {
                      NSDictionary* dict = [NSJSONSerialization JSONObjectWithData:resultObject options:NSJSONReadingAllowFragments error:nil];
                      NSMutableDictionary *resultDict = [NSMutableDictionary dictionary];
                      //人脸注册成功
                      if ([dict[@"error_msg"] isEqualToString:@"SUCCESS"]) {
                          [resultDict setValue:dict[@"result"][@"face_token"] forKey:@"face_token"];
                          [resultDict setValue:[NSNumber numberWithBool:true] forKey:@"type"];
                      }else{
                          [resultDict setValue:[NSNumber numberWithBool:false] forKey:@"type"];
                      }
                      NSLog(@"error=%@\nresult=%@",error,dict);
                      
                      result(resultDict);
                  }];
              }
          };
          
//          UINavigationController *nav = [[UINavigationController alloc]initWithRootViewController:vc];
          vc.modalPresentationStyle = UIModalPresentationFullScreen;
          if (self.hostViewController != nil) {
              [self.hostViewController presentViewController:vc animated:YES completion:nil];
          }
      }
  else {
    result(FlutterMethodNotImplemented);
  }
}

@end
